//
//  CommandViewController.m
//  LT OTA
//
//  Created by PINWU KAO on 12/16/14.
//  Copyright (c) 2014 Laird Technologies. All rights reserved.
//

#import "ViewController.h"
#import "CommandViewController.h"
#import "CommandCellDetail.h"

@interface CommandViewController ()
@property NSTimer     * runTimer;
@end

@implementation CommandViewController
{
    NSArray *commandsArray;
    NSString *strCommand;
    int idleCount;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    NSString *string0 = @"AT+DEL \"file_name\"";
    NSString *string1 = @"AT+RUN \"file_name\"";
    NSString *string2 = @"ATZ";
    commandsArray = @[string0, string1, string2];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (void) viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.selectedRow = -1;
    self.tfFileName.text = self.rootView.labelSaveAs.text;
}

- (void) viewWillDisappear:(BOOL)animated
{
    if(self.runTimer)
    {
        [self.runTimer invalidate];
        self.runTimer = nil;
    }
}

- (void) getResponse:(NSTimer *) theTimer
{
    int errCode;
    NSString *result = [self.rootView CheckResponse:&errCode];
    if(errCode != 0 || result != nil)
    {
        [self.runTimer invalidate];
        self.runTimer = nil;
        if(result != nil)  self.tvResults.text = result;
        self.backButton.hidden = NO;
        self.runButton.hidden = NO;
    }
    else if(++idleCount >= 100)
    {
        idleCount = 0;
        [self.runTimer invalidate];
        self.runTimer = nil;
        self.tvResults.text = [NSString stringWithFormat:@"Timeout for %@", strCommand];
        self.backButton.hidden = NO;
        self.runButton.hidden = NO;
    }
    else if(self.selectedRow == 2)
    {
        [self.runTimer invalidate];
        self.runTimer = nil;
        self.backButton.hidden = NO;
        self.runButton.hidden = NO;
        [self.navigationController popViewControllerAnimated:YES];
    }
}

- (IBAction)runButtonPressed:(id)sender {
    self.tvResults.text = @"";
    
    if(self.selectedRow >= 0)
    {
        strCommand = nil;
        
        switch(self.selectedRow)
        {
            case 0:
                strCommand = [NSString stringWithFormat:@"AT+DEL \"%@\"", self.tfFileName.text];
                break;
            case 1:
                strCommand = [NSString stringWithFormat:@"AT+RUN \"%@\"", self.tfFileName.text];
                break;
            case 2:
                strCommand = @"ATZ";
                break;
        }
        
        if(strCommand != nil)
        {
            self.backButton.hidden = YES;
            self.runButton.hidden = YES;
            idleCount = 0;
            strCommand = [strCommand stringByAppendingString :@"\r"];
            [self.rootView sendOneCommand:strCommand];
            self.runTimer = [NSTimer scheduledTimerWithTimeInterval:0.1
                                                             target:self
                                                           selector:@selector(getResponse:)
                                                           userInfo:nil
                                                            repeats:YES ];
        }
        else
        {
            self.tvResults.text = @"Option Not Supported";
        }
    }
    else
    {
        self.tvResults.text = @"Please Select A Command";
    }
}

- (IBAction)backButtonPressed:(id)sender {
    [self.navigationController popViewControllerAnimated:YES];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [commandsArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *myTableIdentifier = @"CommandCellDetailID";
    // NSLog(@"numberOfRowsInSection: %d", [self.rootView.devicePerpArray count]);
    
    CommandCellDetail *cell = [tableView dequeueReusableCellWithIdentifier:myTableIdentifier];
    
    if (cell == nil) {
        NSLog(@"cellForRowAtIndexPath 1: cell is nil");
        if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone)
            cell = (CommandCellDetail *)[CommandCellDetail cellFromNibNamed:@"CommandDetail_iPhone"];
        else if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
            cell = (CommandCellDetail *)[CommandCellDetail cellFromNibNamed:@"CommandDetail_iPad"];
        if(cell == nil)
            NSLog(@"cellForRowAtIndexPath 2: cell is nil");
    }
    
    cell.commandName.text = [commandsArray objectAtIndex:indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if(indexPath == nil)
        self.selectedRow = -1;
    else
        self.selectedRow = indexPath.row;
}

@end
